LANG OCTASM,0.1
{
define TLU()  task\load(#1,unlock) inc b[ready]
define TLP()  task\load(octasm\fcompiler,task\end,\#1.ASM )
	BPRN(init.asm runing)
	d[exit_code]=230000h
	rdtsc [rand\num]=eax
	ini_video()
	d[win_close]=gui\close d[gui_pausa]=gui\pausa
	d[delay]=1
	bios_prn("%nb Octa V0.%VERSION %10%13 booting from: %10%13")
	bios_prn(system_path) bios_prn("%nb %10%13")
	w[exit_code+2]=24h
	ebp=esp TLU(ini_keyb_ps2mouse,ini_serial_ports,ini_background)
	task\load2(Debug\debug32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,10h)
	d[debugger]=Debug\int_01
	if ESPAOL TLP(LIB\KEYB_ESP) endif
	if ITALIAN TLP(LIB\KEYB_ITA) endif
	if ENGLISH TLP(LIB\KEYB_ENG) endif
      # TLP(PROGS\RELOJ,PROGS\FVIEW\FVIEW)
	w[exit_code+2]=25h
      # wait2ms() test b[ready] jnz <1
	w[exit_code+2]=40h
	generate_crc_tables()
	ebp=esp task\load(wcache,5000) ;flush write cache every 5 seconds
	;task\load2(task\user,0,1)
	;task\load2(usys,0,2)
	task\load2(menu,0bh)
	task\load(compiler32)
	atexit(wait_disks) ;esperar a que se terminen las operaciones de disco
	atexit(writecache)
	cvtfasm()
	w[exit_code+2]=50h
	if USB_TEST
	d[disk\usb\f_out]=\\RD\USB.TXT d[disk\usb\fprn]=fprintf
	printf("usb ready for test%10%0") add esp,4
	endif
	if ATAPI_TEST
	eax=\\RD\TMP\DEBUG.TXT [disk\atapi\d_file]=eax
	d[disk\atapi\f_out]=\\RD\ATAPI.TXT d[disk\atapi\fprn]=fprintf
	endif
	printf("%ums%10%0",[timerdata]) esp+=8 d[exit_code]=0
	cmp d[system_path+2],'\D10' je >1
	eax=0 esi="\\D10\OCTA\OCTA\SYS209\KERNEL.BIN " open() test eax jz >1
	TLP(PROGS\FVIEW\FDISK\BOOTUSB)
      # cmp d[system_path+1],'\\FD' jne >2
	;if boot from floppy read the floppy for the cache
	esi="\\FD " eax=0 open()
	edi=fd_buf ecx=1000h
      # read() cmp ecx,1000h je <1
	close()
      # w[keyb\keyb_delay]=818h
	;eax=9000 wait_ms() al=96h dx=1f7h outb ret

DAT #ready db 0  #fd_buf rb 1000h
CODE
#unlock dec b[ready] jmp task\end

#ini_serial_ports{
 bps1200=96
 bps2400=48
 bps9600=12
#install_com_1
disable_paging() ;because first page not present
push [400h]
enable_paging()
pop dx ;com 1  irq 4
test dx jz install_com_2
setcombufer() [edi+serial\port]=dx b[edi+serial\ints]=3
inc dx al=1 outb inc dx al=87h outb inb
ebx=1040101h test al,64 jz >1
bx=1008h
#
[edi+serial\read_fifo]=ebx  ;read,write,ints
ecx=bps1200
setcomrate()
[irqc4cvar-4]=edi
add dx,2 al=0 outb
IRQS(int_24,_4,4)
install_mouse() jnc >1
ecx=1 setcomrate()
#

#install_com_2
pop dx ;com 2 irq 3
test dx jz install_com_3
setcombufer() [edi+serial\port]=dx b[edi+serial\ints]=3
inc dx al=1 outb inc dx al=87h outb inb
ebx=1040101h test al,64 jz >1
bx=1008h
#
[edi+serial\read_fifo]=ebx  ;read,write,ints
ecx=bps1200 setcomrate()
[irqc3cvar-4]=edi
add dx,2 al=0 outb
IRQS(int_23,_3,3)
install_mouse() jnc >1
ecx=1 setcomrate()
#

#install_com_3
ret

#setcombufer
	ecx=2048+2048+12+12+16 mallocz()
	d[edi+16+8]=2047 d[edi+16+8+12+2048]=2047 ret

#install_mouse
eax=10 wait_ms() esi=edi+16
# getbc() jnc <1
al=1011b outb
eax=100 wait_ms()
getbc() jnc >1
eax=200 wait_ms() getbc() jc >2
# and al,7fh cmp al,'M' jne >1
ebp=esp task\load(serialmouse,esi)
b[esi-16+serial\read_fifo]=1
dx=[esi-16+serial\port] add dx,2
al=7 outb ;poner fifo a 1 byte para mejorar el tiempo de respuesta
init_winmouse()
PRN(serial mouse installed)
clc ret
# stc ret
	}
#init_winmouse
	d[winmouse\vx1]=8 d[winmouse\vy1]=19
	d[mousevx]=9 d[mousevy]=20
	ret

#wait2ms pushad eax=2 wait_ms() popad ret

#ini_background
     eax=\FONDO img\info() test ebp jz close
     eax=[gui\list2] esi=[eax] al=[esi+gui\pid]
     ecx=6+8 mallocz() [edi+10]=ebp d[edi+6]='jpg ' [edi+5]=al
     correo\enviar() ret

#ini_video w[exit_code+2]=10h
	colorprecalc() set_paleta242()
	w[exit_code+2]=11h
	disable_paging()
	;detect_videomodes() ;returns eax
	d[video_mem]=10000h eax=13h
	w[exit_code+2]=20h
	gui\videomode(eax) jnc >1
	w[exit_code]=10h jmp exit
      # w[exit_code+2]=22h
	ebx=[video_base_ptr] eax=ebx+3 ecx=[video_mem]
	shr ecx,12 w[exit_code+2]=21h
	setpages(ebx,eax,ecx)
	enable_paging()
	ecx=9*20*4 mallocz()
	[winmouse\bufer]=edi
	edi=winmouse gui\top_ins() inc d[gui\n_win2]
	esi=Compressed_cpi eax=3394
	edi=[cpi] ecx=4000h
	bl=-15 zlib\uncompress2()
	ebp=esp task\load2(stdout,0ah) task\load(gui\wintext)
	d[std_out]=bios_prn
	w[exit_code+2]=23h
	ret

#set_paleta242
	DAT4
      #pa db 0*4,4*4,8*4,13*4,17*4,21*4,25*4,29*4,34*4,38*4,42*4,46*4,50*4,55*4,59*4,63*4
	db 0*4,21*4,42*4,63*4
	CODE
	edi=paleta242+1024 ;graf.asm usada en modos 8bpp
	eax=3 ebx=0 ecx=256
      # bl=al ah=[pa+ebx+16] cl=15
      # bl=cl ch=[pa+ebx] dl=3
      # bl=dl dh=[pa+ebx+16]
	--edi b[edi]=0
	--edi [edi]=ah
	--edi [edi]=ch
	--edi [edi]=dh
	--dl jns <1
	--cl jns <2
	--al jns <3
	ret

DAT4
;R = Y                    + 1.402  *(Cr-128)
;G = Y - 0.34414*(Cb-128) - 0.71414*(Cr-128)
;B = Y + 1.772  *(Cb-128)
# float 1.402,-0.71414,-0.34414,+1.772
CODE

#colorprecalc ;prepara la tabla para convertir ycb a rgb
	edi=colortabla
	fninit fld d[<1+4] fld d[<1]
	dl=0 call >1 fld d[<1+12] fld d[<1+8] call >1 ret
      # cx=-128
      # [edi]=cx ++cx fild w[edi] fld st0 fmul st2 fistp w[edi]
	fmul st2 fistp w[edi+2] edi+=4
	++dl jnz <1 ret

#ide_irqs ;a veces se cuelga
IRQS(int_2a,_10,10,int_2b,_11,11,int_2e,_14,14,int_2f,_15,15)
ret

#detect_videomodes{
w[exit_code+2]=18h
max_resolution()
w[exit_code+2]=19h
esp-=1020 push 'VBE2'
w[exit_code+2]=12h d[video_mem]=10000h ;in case vesa is not suported
eax=04f00h edi=esp rm_int(10h) cmp ax,4fh jne exit
eax=[esp+12h] [video_mem+2]=ax
eax=w[0eh+esp] esi=w[10h+esp]
shl esi,4 esi+=eax
w[exit_code+2]=13h
DAT4 #vid_modes_lst rb 200h
CODE
edi=vid_modes_lst ecx=100h-1
# lodsw cmp ax,-1 je >1
  stosw loop <1
# w[edi]=-1 esi=vid_modes_lst
#l1 cx=w[esi] esi+=2 cmp cx,-1 je l2
test ch jz l1 ;skip non vesa modes
w[exit_code+2]=14h
ax=4f01h edi=esp+512
push esi rm_int(10h)
pop esi cmp ax,4fh jne l2
eax=[edi] al&=17 cmp al,17 jne l1   ;supported graphic mode?
edx=[edi+12h] cmp edx,[xmax] ja l1
cmp dx,[xmax] ja l1
al=[edi+19h]
cmp al,8 je >1
cmp al,16 je >1
cmp al,24 je >1
cmp al,32 jne l1
#
ebx=b[n_modes]
[ebx*8+videomodes]=ax [ebx*8+videomodes+2]=edx [ebx*8+videomodes+6]=cx
++b[n_modes] jnz l1
#l2
w[exit_code+2]=15h
eax=b[n_modes] cmp eax,2 jc exit
qsort(videomodes,eax,8,sort_vid)
w[exit_code+2]=16h
ecx=b[n_modes] ++ecx shl ecx,4 mallocz()
[menu_video]=edi d[edi+4]='MN12' edi+=16
esi=videomodes
#l3 eax=w[esi+6] or eax,10000h stosd
eax=w[esi+2] cx=40ah ltoa() al='*' stosb
eax=w[esi+4] ltoa() al='*' stosb
eax=b[esi] ch=2 ltoa()
esi+=8 --b[n_modes] jnz l3

#exit
add esp,1024 ;512+256
esi=videomodes-8 w[exit_code+2]=17h
# ebx=[esi+10] eax=w[esi+14]
# esi+=8 ecx=[esi+2] jecxz >3
  cmp ecx,[default_resolution] je >2
  test b[max_res] jz >1
  cmp ecx,ebx ja <2 jmp <1 ;set the max resolution
;unknow max resolution, set a low resolution
# cmp ecx,ebx jc <3 jmp <2
# eax=w[esi+6]
# ret

#sort_vid
 push eax ax=[edi] cmp ax,[esi] jne >1
 eax=[edi+2] cmp eax,[esi+2]
# pop eax ret

#max_resolution {
esp-=128 edi=esp
eax=4f15h ebx=1 ecx=0 edx=0 rm_int(10h)
cmp ax,4fh jne exit
w[exit_code+2]=1bh
esi=esp+26h ecx=4 ebx=0
# lodsw cmp ax,bx jc >1 bx=ax # loop <2
test bx jz l1
cmp bx,101h je l1
push ebx ebx=bl ebx=(ebx+31)*8 [xmax]=bx b[max_res]=1
pop eax shr eax,14
fld d[eax*4+>1]
DAT4 # float 1,0.75,0.8,0.5625
CODE
push ebx fimul d[esp] fistp d[esp]
pop ebx [ymax]=bx
#exit esp+=128 ret
#l1
 eax=[esp+23h] test eax,0ffc0h jz >1
 b[max_res]=1
 d[xmax]=800+600*10000h
 test eax,0f000h jz >1
 d[xmax]=1024+768*10000h
 test ax jns >1
 d[xmax]=1280+1024*10000h
# jmp exit
}

DAT4
#xmax dw -1
#ymax dw -1
;set here the monitor resolution you want to use by default for example:
#default_resolution dw 1024,768
#n_modes db 0
#max_res db 0
#videomodes dw 8,320,200,13h rb 8*256  ;dw bpp,x,y,vesa_mode
}

#ini_keyb_ps2mouse
	keybclear()
	kb_wait() al=60h out 64h,al  ; write back command byte
	kb_wait() al=47h out 60h,al  ; enable keyb,and mouse
;ini_keyb
	ecx=134 mallocz2()
	[cv1-4]=edi
	d[keyb\bufer]=edi
	w[edi+4]=127
	IRQS(int_21,_1,1) eax=b[keyb\adm+1]
	ebp=esp task\load2(keyb\driver,0,0,10000H,0,0,0,eax)
;ini_ps2mouse
	ebp=esp
	ecx=134 mallocz2() [cv12-4]=edi
	push edi eax=0 [edi]=eax w[edi+4]=127
	IRQS(int_2c,_12,12)
;portdata en edi
	esi=edi
      # auxr() jnc <1  ;vaciar bufer
	ah=0f5h auxc1() jnc >2    ;disable stream mode
      # auxr() jnc <1  ;vaciar bufer
	ah=0f5h auxc1() ;retry
      # ah=0ffh auxc1() jc no_ps2mouse
	cl=0 auxr2() cmp al,0aah jne no_ps2mouse
	auxr() cmp al,0 jne no_ps2mouse
	eax=0f3c8f364h auxc4() ;detect scroll mouse
	ax=0f350h auxc2() jc no_ps2mouse
	ah=0f2h auxc1()  jc no_ps2mouse
	auxr()
	edx=ps2mouse cmp al,3 jne >1
	eax=0f3c8f3c8h auxc4() ;set mode scroll mouse + 5 botones
	ax=0f350h auxc2() jc no_ps2mouse
	ah=0f2h auxc1() auxr()
	edx=ps2mouse5b  ;lo mismo para 3 o 5 botones
      # ax=0e803h auxc2() jc no_ps2mouse ;resolution
	ah=0e6h auxc1() jc no_ps2mouse ;scaling
	ax=0f328h auxc2() jc no_ps2mouse ;rate
	ah=0f4h ;enable stream mode
	auxc1() jc no_ps2mouse
	init_winmouse()
	PRN(ps2 mouse enabled )
	pop edi ebp=esp
	task\load(edx,edi)
	clc ret
	#no_ps2mouse
	PRN(NO PS2 MOUSE)
	pop edi stc ret

#auxc4
	push eax shr eax,16 auxc2()
	pop eax jc >1
	auxc2()
      # ret

#auxc2        ;ah (b1),al (b2)
	push ax auxc1()
	pop ax jc >1
	ah=al auxc1()
      # ret

#auxc1
	auxw() auxr() jc >2
	cmp al,0feh jne >1           ;resend
	auxw() auxr() jc >2
      # cmp al,0fah je >1
	stc
      # ret

#auxw  ;comando en ah
	kb_wait() al=0d4h out 64h,al
	kb_wait() al=ah out 60h,al ret

#auxr   cl=20
#auxr2  dec cl jz >1
	wait2ms()
	;test w[esi],-1 jz auxr2
	getbc32w() jc auxr2 ret
      # in al,60h stc ret

#kb_wait ecx=100h      ; wait for safe to write to 8042
      # wait2ms() in al,64h test al,2 loopne <1 jnz >1
	ret
      # PRN( error kb_wait) stc ret

#keybclear ;clear keyb bufer
      # in al,60h wait2ms() in al,64h test al,1 jnz <1
	ret

#cvtfasm{    ;creates file \\RD\FASM.INC
esi=f_in
edi=f_out2
#next_line
add esi,[level]
[last_word]=edi
copy_prefix()
# lodsb
cmp al,'{' je inc_prefix
cmp al,'}' je dec_prefix
stosb cmp al,10 ja <1 je next_line
#end
 ecx=edi-f_out edi=f_out esi="\\RD\FASM.INC " jmp store_file_2

#copy_prefix
	push esi esi=prefix
	ecx=[prefix_size] rep movsb
	pop esi
	ret

#inc_prefix
pusha
inc d[level] ecx=edi
edi=prefix
esi=[last_word] sub ecx,esi
rep movsb al='.' stosb
ecx=edi-prefix [prefix_size]=ecx
popa edi=[last_word] lodsb cmp al,'}' jne next_line
#dec_prefix
pusha
dec d[level]
ecx=[prefix_size]
# cmp b[ecx+prefix-2],'.' loopne <1
[prefix_size]=ecx
popa lodsb cmp al,'}' je dec_prefix
stosb jmp next_line

DAT4
#last_word rb 4
#prefix_size rb 4
#prefix
rb 100h
#level rb 4
#f_out
include \LIB\FASM\FASM.INC
#f_out2
rb 100000
#f_in
include \\RD\KERNEL.SYM ,16
db 0
}

#generate_crc_tables
	edi=t_crc16 ebx=8408h call >1
	ebx=0edb88320h
	;edi=256*4 bufer ,ebx=polynomial (=[128*4])
      # ecx=0
      # eax=ch cl=8
      # shr eax,1 jnc >1
	xor eax,ebx
      # dec cl jnz <2
	stosd inc ch jnz <3
	ret

#Compressed_cpi include \LIB\CPI.Z
}

